var BrandBox = React.createClass({
    getInitialState: function () {
        return {options: this.props.options, opened: false};
    },
    handleChange: function (id) {
        var state = this.state.options.map(function (item) {
            return {
                id: item.id,
                label: item.label,
                selected: (item.id === id ? !item.selected : item.selected)
            };
        });

        this.setState({options: state, opened: this.state.opened});

        let selectedIds = [];
        selectedIds = state.filter(function (item) {
            return item.selected === true;
        }).map(item => item.id);

        this.props.onChange({
            brands: selectedIds
        });
    },
    handleToggle: function () {
        this.setState({options: this.state.options, opened: !this.state.opened});
        $(this.itemsList).slideToggle();
    },
    render: function () {

        var items = [];
        this.state.options.forEach((item) => {
            items.push(
                <li>
                    <label>
                        <input checked={item.selected} type="checkbox"
                               data-id={item.id} onChange={this.handleChange.bind(this, item.id)}/>
                        <span></span> {item.label}
                    </label>
                </li>);
        });

        var wrapperClasses = ['filter-wrapper', 'filter-trademark'];
        var titleClasses = ['filter-title', '_has-inner'];
        var ulStyle = {};

        if (this.state.opened) {
            titleClasses.push('_open');
        }

        wrapperClasses = wrapperClasses.join(' ');
        titleClasses = titleClasses.join(' ');

        return (
            <div className={wrapperClasses}>
                <div className={titleClasses} onClick={this.handleToggle.bind(this)}>
                    {this.props.title}
                    <span className="arrow"></span>
                </div>
                <ul className="filter-list" style={ulStyle} ref={(el) => { this.itemsList = el; }}>
                    {items}
                </ul>
            </div>
        );
    }
});

function brandsHandler(event) {
    window.queryFilter.brand = event.brands;
    console.log('brand')
    catalogfilterChanged();
}

let brandSelectorElement = document.getElementById('product-brand-selector');
if (brandSelectorElement) {
    let title = brandSelectorElement.getAttribute('title');
    ReactDOM.render(<BrandBox options={brands} title={title} onChange={brandsHandler}/>, brandSelectorElement);
}
